﻿using System.Windows;
using BlueMarble.Genesis.Infrastructure;
using System.Windows.Media.Animation;
using System.Windows.Controls;
using Microsoft.Practices.Composite.Regions;
using System;

namespace BlueMarble.Genesis.Shell
{
    /// <summary>
    /// Interaction logic for ShellView.xaml
    /// </summary>
    public partial class View : Window, IShellView
    {
        protected IShellViewModel viewModel;

        public View()
        {
            InitializeComponent();
        }

        #region IShellView

        public IShellViewModel ViewModel
        {
            get
            {
                return viewModel;
            }

            set
            {
                viewModel = value;
            }
        }

        public void ShowView()
        {
            this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal,
                new Action(
                    delegate() { this.Show(); }));
        }

        #endregion
    }
}
