#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Genesis.Common.Classes;
using Genesis.Common.Interfaces;

namespace Genesis.Client.Common.Classes
{
    public class ExceptionProvider : ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public ExceptionProvider()
        {
            base.WebService = new Genesis.Client.Common.WebService.Exception.Exception();
            base.WebService.Url = base.ServerAddress + "Exception.ASMX";
        }

        public void LogException(System.Exception Exception)
        {
            try
            {
                System.Xml.XmlDocument xmlExceptionDocument = new System.Xml.XmlDocument();

                xmlExceptionDocument.LoadXml(@"<?xml version=""1.0"" encoding=""utf-8"" ?><Root></Root>");

                System.Xml.XmlNode xmlExceptionNode = xmlExceptionDocument.DocumentElement;

                xmlExceptionNode.InnerXml = processExceptionXml(Exception);

                System.Xml.XmlNode xmlLocalInformationNode = xmlExceptionDocument.CreateElement("ClientInformation");

                xmlLocalInformationNode.InnerXml = "<localaddress>{0}</localaddress><username>{1}</username>";

                xmlExceptionNode.AppendChild(xmlLocalInformationNode);

                ((Genesis.Client.Common.WebService.Exception.Exception)WebService).LogException(xmlExceptionNode);
            }
            catch
            {
                System.Exception logException = new Exception("Unable to connect to exception server", Exception);

                throw logException;
            }
        }

        protected string processExceptionXml(System.Exception exception)
        {
            string xmlException = string.Format(@"<Exception> <Message><![CDATA[{0}]]></Message> <Source><![CDATA[{1}]]></Source> <StackTrace><![CDATA[{2}]]></StackTrace> ",
                exception.Message, exception.Source, exception.StackTrace);

            if (exception.InnerException != null)
            {
                xmlException += processExceptionXml(exception.InnerException);
            }

            xmlException += @"</Exception>";

            return xmlException;
        }
    }
}
