#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Genesis.Common.Classes;
using Genesis.Common.Interfaces;

namespace Genesis.Client.Common.Classes
{
    public class FileManagerProvider : ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public FileManagerProvider()
        {
            try
            {
                base.WebService = new Genesis.Client.Common.WebService.FileManager.FileManager();
                base.WebService.Url = base.ServerAddress + "FileManager.ASMX";

                base.setWebServiceProxy();
            }   
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }

        public Guid UploadFile(string DocumentType, string FileName, string FileType, int FileSize, Guid UserGuid)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).UploadFile(DocumentType, FileName, FileType, FileSize, UserGuid);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public Guid UploadDebtorDocument(Guid DocumentGuid, int DebtorProfileId, int DebtorAccountId)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).UploadDebtorDocument(DocumentGuid, DebtorProfileId, DebtorAccountId);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public Guid UploadSubscriberLogo(string FileName, string FileType, int FileSize, int SubscriberConfigurationId)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).UploadSubscriberLogo(FileName, FileType, FileSize, SubscriberConfigurationId);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public Guid UploadSourceLogo(string FileName, string FileType, int FileSize, int SourceConfigurationId)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).UploadSourceLogo(FileName, FileType, FileSize, SourceConfigurationId);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public void UploadFilePart(Guid DebtorDocumentGuid, int FilePartNumber, byte[] FilePart)
        {
            try
            {
                ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).UploadFilePart(DebtorDocumentGuid, FilePartNumber, FilePart);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }

        public void JoinFileParts(Guid DebtorDocumentGuid)
        {
            try
            {
                ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).JoinFileParts(DebtorDocumentGuid);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }

        public void DeleteTemporaryFolder(Guid DebtorDocumentGuid)
        {
            try
            {
                ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).DeleteTemporaryFolder(DebtorDocumentGuid);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }

        public int GetArraySize()
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.FileManager.FileManager)WebService).GetArraySize();
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }
    }
}
