#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Genesis.Common.Classes;
using Genesis.Common.Interfaces;

namespace Genesis.Client.Common.Classes
{
    public class GenesisProvider : ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public GenesisProvider()
        {
            try
            {
                base.WebService = new Genesis.Client.Common.WebService.Genesis.Genesis();
                base.WebService.Url = base.ServerAddress + "Genesis.ASMX";

                base.setWebServiceProxy();
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }

        public System.Data.DataTable ExecuteTable(string CommandText, string ConnectionStringKey, Genesis.Client.Common.WebService.Genesis.CommandType CommandType, string TableName, params Genesis.Client.Common.WebService.Genesis.DataParameter[] Parameters)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = (System.Data.DataTable)((Genesis.Client.Common.WebService.Genesis.Genesis)WebService).ExecuteTable(this.TransactionGuid, CommandText, ConnectionStringKey, CommandType, TableName, Parameters);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public object ExecuteScalar(string CommandText, string ConnectionStringKey, Genesis.Client.Common.WebService.Genesis.CommandType CommandType, string TableName, params Genesis.Client.Common.WebService.Genesis.DataParameter[] Parameters)
        {
            object resultValue = null;

            try
            {
                resultValue = (object)((Genesis.Client.Common.WebService.Genesis.Genesis)WebService).ExecuteScalar(this.TransactionGuid, CommandText, ConnectionStringKey, CommandType, TableName, Parameters);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }

            return resultValue;
        }

        public void ExecuteNonQuery(string CommandText, string ConnectionStringKey, Genesis.Client.Common.WebService.Genesis.CommandType CommandType, string TableName, params Genesis.Client.Common.WebService.Genesis.DataParameter[] Parameters)
        {
            try
            {
                ((Genesis.Client.Common.WebService.Genesis.Genesis)WebService).ExecuteNonQuery(this.TransactionGuid, CommandText, ConnectionStringKey, CommandType, TableName, Parameters);
            }
            catch (System.Exception exception)
            {
                Genesis.Client.Common.Classes.ExceptionHandler.HandleException(exception);
            }
        }
    }
}
