#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Genesis.Common.Classes;
using Genesis.Common.Interfaces;

namespace Genesis.Client.Common.Classes
{
    public class KeepAliveProvider : ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public KeepAliveProvider()
        {
            try
            {
                base.WebService = new Genesis.Client.Common.WebService.KeepAlive.KeepAlive();
                base.WebService.Url = base.ServerAddress + "KeepAlive.ASMX";

                base.setWebServiceProxy();
            }
            catch (System.Exception exception)
            {
                throw exception;
            }
        }

        public string Ping()
        {
            string resultValue = "";

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.KeepAlive.KeepAlive)WebService).Ping();
            }
            catch (System.Exception exception)
            {
                throw exception;
            }

            return resultValue;
        }

        public System.Xml.XmlNode Test(System.Xml.XmlNode TestNode)
        {
            System.Xml.XmlNode resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Common.WebService.KeepAlive.KeepAlive)WebService).Test(TestNode);
            }
            catch (System.Exception exception)
            {
                throw exception;
            }

            return resultValue;
        }
    }
}
