#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using Genesis.Common.Classes;
using Genesis.Common.Interfaces;

namespace Genesis.Client.Common.Classes
{
    public class LookupProvider: ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public LookupProvider()
        {
            base.WebService = new Genesis.Client.Common.WebService.Lookup.Lookup();
            base.WebService.Url = base.ServerAddress + "Lookup.ASMX";

            base.setWebServiceProxy();
        }

        public DataTable GetLookupValues(string TableName, string ValueColumnName, string DisplayColumnName)
        {
            return (DataTable)((Genesis.Client.Common.WebService.Lookup.Lookup)WebService).GetLookupValues(TableName, ValueColumnName, DisplayColumnName);
        }

        public DataTable GetLookupValues(string TableName, string ValueColumnName, string DisplayColumnName, string ConnectionStringKey)
        {
            return (DataTable)((Genesis.Client.Common.WebService.Lookup.Lookup)WebService).GetLookupValuesUsingConnection(TableName, ValueColumnName, DisplayColumnName, ConnectionStringKey);
        }
    }
}
