#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Genesis.Common.Classes;

namespace Genesis.Client.Common.Classes
{
    public partial class WizardBase : Form
    {
        protected Genesis.Common.Interfaces.IHost host;
        protected List<PageProperty> pageProperties;

        public WizardBase()
        {
            InitializeComponent();

            pageProperties = new List<PageProperty>();
        }

        public Genesis.Common.Interfaces.IHost Host
        {
            get
            {
                return host;
            }

            set
            {
                host = value;
            }
        }

        public List<PageProperty> PageProperties
        {
            get
            {
                return pageProperties;
            }
            set
            {
                pageProperties = value;
            }
        }

        protected PageProperty getPageProperty(string PropertyName)
        {
            for (int i = 0; i < pageProperties.Count; i++)
            {
                if (pageProperties[i].Name == PropertyName)
                {
                    return pageProperties[i];
                }
            }

            return null;
        }
    }
}