#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Genesis.Client.Common.Forms
{
    public partial class ExceptionForm : Genesis.Client.Common.Classes.DialogBase
    {
        protected System.Exception exception;

        public ExceptionForm()
        {
            InitializeComponent();

            this.exception = null;
        }

        public System.Exception Exception
        {
            get { return this.exception; }
            set
            {
                this.exception = value;

                if (this.exception != null)
                {
                    StringBuilder exceptionHtml = new StringBuilder();

                    exceptionHtml.Append("<html><body>");

                    exceptionHtml.Append("<table style=\"font-size: smaller;\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\" border=\"0\">");
                    exceptionHtml.AppendFormat("<tr style=\"font-size: normal; color: white; background-color: lightblue; font-weight: bold;\"><td>{0}</td><tr>", "An error has occured");

                    exceptionHtml.AppendFormat("<tr valing=\"top\"><td colspan=\"2\">{0}</td><tr>", this.getHtmlForException(exception));

                    exceptionHtml.AppendFormat("<tr><td>{0}</td><tr>", "You can contact <a target=\"new\" href=\"http://www.bluemarble.co.za/\">Blue Marble</a> to report this error.");
                    exceptionHtml.Append("</table>");

                    exceptionHtml.Append("</body></html>");

                    webBrowser1.DocumentText = exceptionHtml.ToString();
                }
            }
        }

        protected string getHtmlForException(System.Exception innerException)
        {
            StringBuilder returnValue = new StringBuilder();

            returnValue.Append("<div>");

            returnValue.Append("<table style=\"font-size: smaller;\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">");

            returnValue.AppendFormat("<tr valing=\"top\" style=\"font-weight: bolder; font-size: normal;\"><td>{0}</td></tr><tr><td style=\"font-size: normal; color: seagreen;\">{1}</td></tr>", "Message", innerException.Message);
            returnValue.AppendFormat("<tr valing=\"top\" style=\"font-weight: bolder;\"><td>{0}</td></tr><tr><td style=\"color: gray;\">{1}</td></tr>", "Source", innerException.Source);
            returnValue.AppendFormat("<tr valing=\"top\" style=\"font-weight: bolder;\"><td>{0}</td></tr><tr><td style=\"color: gray;\">{1}</td></tr>", "Stack Trace", innerException.StackTrace);
            returnValue.AppendFormat("<tr valing=\"top\" style=\"font-weight: bolder;\"><td>{0}</td></tr><tr><td style=\"color: gray;\">{1}</td></tr>", "Target Site", innerException.TargetSite);

            returnValue.Append("</table>");

            returnValue.Append("<br/>");

            if (innerException.InnerException != null)
            {
                returnValue.Append(this.getHtmlForException(innerException.InnerException));
            }

            returnValue.Append("</div>");

            return returnValue.ToString();
        }

        public static void Show(Exception Exception)
        {
            ExceptionForm exceptionForm = new ExceptionForm();

            exceptionForm.Exception = Exception;

            exceptionForm.ShowDialog();
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;

            this.Close();
        }
    }
}