#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace Genesis.Client.Module.Classes
{
    public class ModuleProvider : Genesis.Common.Classes.ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public ModuleProvider()
        {
            try
            {
                base.WebService = new Genesis.Client.Module.WebService.Module.Module();
                base.WebService.Url = base.ServerAddress + "Module.ASMX";

                base.setWebServiceProxy();
            }
            catch
            {
                throw;
            }
        }

        public DataTable GetApplicationRibbons()
        {
            DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.WebService).GetApplicationRibbons(base.sessionGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public DataTable GetRibbonBars(Guid RibbonGuid)
        {
            DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.WebService).GetRibbonBars(this.sessionGuid, RibbonGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public DataTable GetBarItems(Guid RibbonBarGuid, Guid ParentBarItemGuid)
        {
            DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).GetBarItems(this.sessionGuid, RibbonBarGuid, ParentBarItemGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public DataTable GetApplicationFiles(Guid ApplicationGuid)
        {
            DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.WebService).GetApplicationFiles(this.sessionGuid, ApplicationGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public DataTable GetApplicationCommands(Guid FileGuid)
        {
            DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.WebService).GetApplicationCommands(this.sessionGuid, FileGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable ApplicationGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).ApplicationGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable ApplicationGetByApplicationGuid(Guid ApplicationGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).ApplicationGetByApplicationGuid(ApplicationGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool ApplicationUpdate(Guid ApplicationGuid, int ApplicationId, string ApplicationName, string ApplicationDescription, int Order, bool Visible)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).ApplicationUpdate(ApplicationId, ApplicationGuid, ApplicationName, ApplicationDescription, Order, Visible);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int ApplicationInsert(Guid ApplicationGuid, string ApplicationName, string ApplicationDescription, int Order, bool Visible)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).ApplicationInsert(ApplicationGuid, ApplicationName, ApplicationDescription, Order, Visible);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable FileGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).FileGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable FileGetByFileGuid(Guid FileGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).FileGetByFileGuid(FileGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable FileGetByFileTypeId(int FileTypeId)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).FileGetByFileTypeId(FileTypeId);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool FileUpdate(Guid FileGuid, int FileId, Guid ApplicationGuid, string FileName, string FileDescription, string FilePath, string FileUrl, int FileTypeId, int VersionMajor, int VersionMinor, int VersionBuild, int VersionRevision, int Order)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).FileUpdate(FileId, FileGuid, ApplicationGuid, FileName, FileDescription, FilePath, FileUrl, FileTypeId, VersionMajor, VersionMinor, VersionBuild, VersionRevision, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int FileInsert(Guid FileGuid, Guid ApplicationGuid, string FileName, string FileDescription, string FilePath, string FileUrl, int FileTypeId, int VersionMajor, int VersionMinor, int VersionBuild, int VersionRevision, int Order)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).FileInsert(FileGuid, ApplicationGuid, FileName, FileDescription, FilePath, FileUrl, FileTypeId, VersionMajor, VersionMinor, VersionBuild, VersionRevision, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable CommandGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).CommandGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable CommandGetListWithNullRecord()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).CommandGetListWithNullRecord();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable CommandGetByCommandGuid(Guid CommandGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).CommandGetByCommandGuid(CommandGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool CommandUpdate(Guid CommandGuid, int CommandId, Guid FileGuid, string CommandName, string CommandDescription, string CommandCode, string CommandType)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).CommandUpdate(CommandId, CommandGuid, FileGuid, CommandName, CommandDescription, CommandCode, CommandType);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int CommandInsert(Guid CommandGuid, Guid FileGuid, string CommandName, string CommandDescription, string CommandCode, string CommandType)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).CommandInsert(CommandGuid, FileGuid, CommandName, CommandDescription, CommandCode, CommandType);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonGetByRibbonGuid(Guid RibbonGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonGetByRibbonGuid(RibbonGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool RibbonUpdate(int RibbonId, Guid RibbonGuid, Guid ApplicationGuid, string RibbonName, int Order)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonUpdate(RibbonId, RibbonGuid, ApplicationGuid, RibbonName, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonInsert(Guid RibbonGuid, Guid ApplicationGuid, string RibbonName, int Order)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonInsert(RibbonGuid, ApplicationGuid, RibbonName, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonBarGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonBarGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonBarGetByRibbonBarGuid(Guid RibbonBarGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonBarGetByRibbonBarGuid(RibbonBarGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool RibbonBarUpdate(int RibbonBarId, Guid RibbonBarGuid, Guid RibbonGuid, string RibbonBarName, int Order)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonBarUpdate(RibbonBarId, RibbonBarGuid, RibbonGuid, RibbonBarName, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonBarInsert(Guid RibbonBarGuid, Guid RibbonGuid, string RibbonBarName, int Order)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).RibbonBarInsert(RibbonBarGuid, RibbonGuid, RibbonBarName, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable BarItemGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).BarItemGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable BarItemGetListWithNullRecord()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).BarItemGetListWithNullRecord();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable BarItemGetByBarItemGuid(Guid BarItemGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).BarItemGetByBarItemGuid(BarItemGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool BarItemUpdate(int BarItemId, Guid BarItemGuid, Guid RibbonBarGuid, Guid ParentBarItemGuid, Guid CommandGuid, string BarItemName, string BarItemImage, int BarItemImageSize, int BarItemTypeId, int Order)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).BarItemUpdate(BarItemId, BarItemGuid, RibbonBarGuid, ParentBarItemGuid, CommandGuid, BarItemName, BarItemImage, BarItemImageSize, BarItemTypeId, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int BarItemInsert(Guid BarItemGuid, Guid RibbonBarGuid, Guid ParentBarItemGuid, Guid CommandGuid, string BarItemName, string BarItemImage, int BarItemImageSize, int BarItemTypeId, int Order)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Module.WebService.Module.Module)base.webService).BarItemInsert(BarItemGuid, RibbonBarGuid, ParentBarItemGuid, CommandGuid, BarItemName, BarItemImage, BarItemImageSize, BarItemTypeId, Order);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
    }
}
