#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Genesis.Client.Security.Classes
{
    public class SecurityProvider: Genesis.Common.Classes.ServiceProviderBase, Genesis.Common.Interfaces.IServiceProvider
    {
        public SecurityProvider()
        {
            try
            {
                base.WebService = new Genesis.Client.Security.WebService.Security.Security();
                base.WebService.Url = base.ServerAddress + "Security.ASMX";

                base.setWebServiceProxy();
            }
            catch
            {
                throw;
            }
        }

        public Guid AuthorizeUser(string Username, string Password, Guid ApplicationGuid)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).AuthorizeUser(ApplicationGuid, Username, Password);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public Guid CreateTransaction(string TransactionCode)
        {
            Guid resultValue = Guid.Empty;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).CreateTransaction(TransactionCode, this.sessionGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }

        public void CompleteTransaction(Guid TransactionGuid)
        {
            try
            {
                ((Genesis.Client.Security.WebService.Security.Security)base.webService).CompleteTransaction(TransactionGuid);
            }
            catch
            {
                throw;
            }
        }
        public System.Data.DataTable RoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByRoleGuid(Guid RoleGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByRoleGuid(RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByUserGuid(Guid UserGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByUserGuid(UserGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByApplicationGuid(Guid ApplicationGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByApplicationGuid(ApplicationGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByCommandGuid(Guid CommandGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByCommandGuid(CommandGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByRibbonGuid(Guid RibbonGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByRibbonGuid(RibbonGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RoleGetByRibbonBarGuid(Guid RibbonBarGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleGetByRibbonBarGuid(RibbonBarGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool RoleUpdate(Guid RoleGuid, int RoleId, string RoleName, string RoleDescription)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleUpdate(RoleId, RoleGuid, RoleName, RoleDescription);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RoleInsert(Guid RoleGuid, string RoleName, string RoleDescription)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RoleInsert(RoleGuid, RoleName, RoleDescription);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable UserGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable UserGetByUserGuid(Guid UserGuid)
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserGetByUserGuid(UserGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public bool UserUpdate(Guid UserGuid, int UserId, string UserName, string Password, string Email, bool Active, string StartupScript)
        {
            bool resultValue = false;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserUpdate(UserId, UserGuid, UserName, Password, Email, Active, StartupScript);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int UserInsert(Guid UserGuid, string UserName, string Password, string Email, bool Active, string StartupScript)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserInsert(UserGuid, UserName, Password, Email, Active, StartupScript);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable UserRoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserRoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int UserRoleInsert(Guid UserGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserRoleInsert(UserGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int UserRoleDelete(Guid UserGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).UserRoleDelete(UserGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable ApplicationRoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).ApplicationRoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int ApplicationRoleInsert(Guid ApplicationGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).ApplicationRoleInsert(ApplicationGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int ApplicationRoleDelete(Guid ApplicationGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).ApplicationRoleDelete(ApplicationGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable CommandRoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).CommandRoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int CommandRoleInsert(Guid CommandGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).CommandRoleInsert(CommandGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int CommandRoleDelete(Guid CommandGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).CommandRoleDelete(CommandGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonRoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonRoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonRoleInsert(Guid RibbonGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonRoleInsert(RibbonGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonRoleDelete(Guid RibbonGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonRoleDelete(RibbonGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public System.Data.DataTable RibbonBarRoleGetList()
        {
            System.Data.DataTable resultValue = null;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonBarRoleGetList();
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonBarRoleInsert(Guid RibbonBarGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonBarRoleInsert(RibbonBarGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
        public int RibbonBarRoleDelete(Guid RibbonBarGuid, Guid RoleGuid)
        {
            int resultValue = 0;

            try
            {
                resultValue = ((Genesis.Client.Security.WebService.Security.Security)base.webService).RibbonBarRoleDelete(RibbonBarGuid, RoleGuid);
            }
            catch
            {
                throw;
            }

            return resultValue;
        }
    }
}
