#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Genesis.Common.Classes
{
    public class CommandBase
    {
        protected List<CommandParameter> parameters;
        protected Genesis.Common.Interfaces.IHost host;
        protected Enumerators.ExecutionStatus executionStatus;

        public CommandBase()
        {
            parameters = new List<CommandParameter>();
            executionStatus = Genesis.Common.Enumerators.ExecutionStatus.NotExecuted;
        }

        #region ICommand Members

        public void Execute()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public List<CommandParameter> Parameters
        {
            get
            {
                return parameters;
            }
            set
            {
                parameters = value;
            }
        }

        public Genesis.Common.Interfaces.IHost Host
        {
            get
            {
                return host;
            }
            set
            {
                host = value;
            }
        }

        public Enumerators.ExecutionStatus ExecutionStatus
        {
            get
            {
                return executionStatus;
            }
        }

        public void ResetCommandParameters()
        {
            parameters.Clear();
        }

        public CommandParameter GetParameterByName(string ParameterName)
        {
            CommandParameter returnValue = null;

            for (int i = 0; i < this.parameters.Count; i++)
            {
                if (this.parameters[i].Name == ParameterName)
                {
                    returnValue = this.parameters[i];
                }
            }

            return returnValue;
        }

        #endregion
    }
}
