#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Genesis.Common.Classes
{
    public class CommandInfoBase: Genesis.Common.Interfaces.ICommandInfo
    {
        protected Genesis.Common.Interfaces.IHost host;
        protected Genesis.Common.Interfaces.ICommand command;

        protected Guid guid;
        protected int id;
        protected Guid fileGuid;
        protected string name;
        protected string code;
        protected string description;

        public CommandInfoBase()
        {
            id = -1;

            guid = global::System.Guid.Empty;
            fileGuid = global::System.Guid.Empty;

            name = null;
            code = null;
            description = null;
        }

        #region ICommand Members

        public Genesis.Common.Interfaces.IHost Host
        {
            get
            {
                return host;
            }
            set
            {
                host = value;
            }
        }

        public Genesis.Common.Interfaces.ICommand Command
        {
            get
            {
                return command;
            }
            set
            {
                command = value;
            }
        }

        public Guid Guid
        {
            get
            {
                return guid;
            }
            set
            {
                guid = value;
            }
        }

        public int Id
        {
            get
            {
                return id;
            }
            set
            {
                id = value;
            }
        }

        public Guid FileGuid
        {
            get
            {
                return fileGuid;
            }
            set
            {
                fileGuid = value;
            }
        }

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }

        public string Code
        {
            get
            {
                return code;
            }
            set
            {
                code = value;
            }
        }

        public string Description
        {
            get
            {
                return description;
            }
            set
            {
                description = value;
            }
        }

        #endregion
    }
}
