#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Genesis.Common.Interfaces
{
    public interface IHost
    {
        void SynchronizeApplicationRibbons();

        List<Genesis.Common.Interfaces.ICommandInfo> Commands
        {
            get;
            set;
        }

        Genesis.Common.Interfaces.ICommand ExecuteCommand(Genesis.Common.Interfaces.ICommandInfo Command);

        Genesis.Common.Interfaces.ICommand ExecuteCommand(Genesis.Common.Interfaces.ICommand Command);

        Genesis.Common.Interfaces.ICommand ExecuteCommand(string CommandCode);

        Genesis.Common.Interfaces.ICommand ExecuteCommand(string CommandCode, params Genesis.Common.Classes.CommandParameter[] Parameters);

        Genesis.Common.Interfaces.ICommand ExecuteCommandUrl(string CommandUrl);

        Genesis.Common.Interfaces.IPage ActivePage
        {
            get;
            set;
        }

        void CreateWindowFromPage(Genesis.Common.Interfaces.IPage Page);

        void CreateWindow(Genesis.Common.Interfaces.IMdiChild MdiChild);

        void CreatePage(Genesis.Common.Interfaces.IPage Page);

        void UpdateNavigation();

        void UpdateTitle(Genesis.Common.Interfaces.IPage Page);

        void UpdateStatusBarText(string Text);

        Classes.GlobalDataSetFunctions GlobalDataSetFunctions
        {
            get;
            set;
        }
    }
}
