#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Genesis.Common.Interfaces
{
    public interface IPage
    {
        bool CanBrowseBack();

        bool CanBrowseForward();

        void BrowseBack();

        void BrowseForward();

        bool CanSave();

        bool CanRefresh();

        bool IsBusy();

        void Refresh();

        void Save();

        void Reload();

        void Closing();

        string GetPageTitle();

        void ResetPageProperties();

        List<Classes.PageProperty> PageProperties
        {
            get;
            set;
        }

        IHost Host
        {
            get;
            set;
        }
    }
}
