#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Genesis.Loader
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            bool developerMode = false;

            for (int i = 0; i < args.Length; i++)
            {
                string argument = args[i];

                if (argument.ToLower() == "/developer")
                {
                    developerMode = true;
                }
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            if (developerMode)
            {
                if (System.IO.File.Exists(AppDomain.CurrentDomain.BaseDirectory + "\\application.xml"))
                {
                    System.IO.File.Delete(AppDomain.CurrentDomain.BaseDirectory + "\\application.xml");
                }
            }

            MainForm mainForm = new MainForm();

            mainForm.RepositionForm();

            Application.Run(mainForm);

            mainForm.Dispose();
        }
    }
}