#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class deployment_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Wizard_FinishButtonClick(object sender, WizardNavigationEventArgs e)
    {
        System.Text.StringBuilder outputString = new System.Text.StringBuilder();

        string deployConfigurationFileName = string.Empty;

        if (Session["DeploymentConfigurationFileName"] != null)
        {
            deployConfigurationFileName = (string)Session["DeploymentConfigurationFileName"];
        }

        if (deployConfigurationFileName != string.Empty)
        {
            System.Xml.XmlDocument deployConfigurationXmlDocument = new System.Xml.XmlDocument();

            deployConfigurationXmlDocument.Load(deployConfigurationFileName);

            System.Xml.XmlNode scriptNodes = deployConfigurationXmlDocument.DocumentElement.SelectSingleNode("/deployment/script");

            foreach (System.Xml.XmlNode scriptNode in scriptNodes.ChildNodes)
            {
                if (scriptNode.Name == "file")
                {
                    string action = string.Empty;
                    string from = string.Empty;
                    string to = string.Empty;
                    string backup = string.Empty;
                    bool overwrite = false;

                    if (scriptNode.Attributes.GetNamedItem("action") != null)
                    {
                        action = scriptNode.Attributes.GetNamedItem("action").Value;
                    }

                    if (scriptNode.Attributes.GetNamedItem("from") != null)
                    {
                        from = scriptNode.Attributes.GetNamedItem("from").Value;

                        if (!System.IO.File.Exists(from))
                        {
                            if (System.IO.File.Exists(System.IO.Path.GetDirectoryName(deployConfigurationFileName) + "\\" + from))
                            {
                                from = System.IO.Path.GetDirectoryName(deployConfigurationFileName) + "\\" + from;
                            }
                        }
                    }
                    if (scriptNode.Attributes.GetNamedItem("to") != null)
                    {
                        to = scriptNode.Attributes.GetNamedItem("to").Value;
                    }

                    if (to != string.Empty)
                    {
                        backup = System.IO.Path.GetDirectoryName(to) + "\\" + System.IO.Path.GetFileNameWithoutExtension(to) + "." + DateTime.Now.ToString("yyyyMMddhhmmss") + System.IO.Path.GetExtension(to) + ".backup";
                    }

                    if (scriptNode.Attributes.GetNamedItem("overwrite") != null)
                    {
                        overwrite = System.Convert.ToBoolean(scriptNode.Attributes.GetNamedItem("overwrite").Value);
                    }

                    if ((to != string.Empty) && (!System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(to))))
                    {
                        System.IO.Directory.CreateDirectory(System.IO.Path.GetDirectoryName(to));
                    }

                    if ((action != string.Empty) && (from != string.Empty) && (to != string.Empty))
                    {
                        if (action == "copy")
                        {
                            outputString.AppendFormat("Copying {0} to {1}<br/>", from, to);
                            if ((!overwrite) && (System.IO.File.Exists(to)))
                            {
                                outputString.AppendFormat("File {1} exists. Overwrite is false. It is recommended to use the 'replace' action<br/>", from, to);
                            }
                            else
                            {
                                System.IO.File.Copy(from, to, overwrite);
                            }
                        }
                        else if (action == "delete")
                        {
                            outputString.AppendFormat("Deleting {1}<br/>", from, to);
                            System.IO.File.Delete(from);
                        }
                        else if (action == "move")
                        {
                            outputString.AppendFormat("Moving {0} to {1}<br/>", from, to);
                            System.IO.File.Move(from, to);
                        }
                        else if (action == "replace")
                        {
                            outputString.AppendFormat("Replacing {0} with {1}<br/>", from, to);
                            if (System.IO.File.Exists(to))
                            {
                                outputString.AppendFormat("Creating backup in {0}<br/>", backup);
                                System.IO.File.Replace(from, to, backup);
                            }
                            else
                            {
                                outputString.AppendFormat("{1} not found, creating from {0}<br/>", from, to);
                                System.IO.File.Copy(from, to);
                            }
                        }
                    }
                }
                else
                {
                }
            }
        }

        outputLabel.Visible = true;
        outputLabel.Text += outputString.ToString();
    }
}
