#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Validators
{
    public class AverageInterestLargerThanContract: ValidatorBase
    {
        public AverageInterestLargerThanContract(Dictionary<string, string> GeneralSettings)
            : base(GeneralSettings)
        {
        }

        public decimal CalculateValueToSetAside(decimal InterestRate, int OriginalContractTerm, decimal OriginalContractValue)
        {
            if (InterestRate > 0.40M)
            {
                return ((((InterestRate - 0.40M) / 12) * OriginalContractTerm) * OriginalContractValue);
            }
            else
            {
                return 0.00M;
            }
        }

        public bool Validate(decimal InterestRate, int OriginalContractTerm, decimal OriginalContractValue)
        {
            bool resultValue = false;

            resultValue = CalculateValueToSetAside(InterestRate, OriginalContractTerm, OriginalContractValue) > 0.00M;

            return resultValue;
        }

        public override bool Validate()
        {
            throw new Exception("Use the Validate(decimal InterestRate, int OriginalContractTerm, decimal OriginalContractValue) overload method.");
        }
    }
}
