#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Validators
{
    public class Balance: ValidatorBase
    {
        public Balance(Dictionary<string, string> GeneralSettings)
            : base(GeneralSettings)
        {
        }

        public decimal CalculateExpectedStatementBalance(decimal OriginalContractValue, decimal CreditLifePayment, int ContractLength, decimal TotalInterestPayment, decimal TotalPaidToDate)
        {
            return ((OriginalContractValue + (CreditLifePayment * ContractLength)) + TotalInterestPayment) - TotalPaidToDate;
        }

        public bool Validate(decimal OriginalContractValue, decimal CreditLifePayment, int ContractLength, decimal TotalInterestPayment, decimal TotalPaidToDate, decimal ClosingBalance)
        {
            bool resultValue = false;

            resultValue = CalculateExpectedStatementBalance(OriginalContractValue, CreditLifePayment, ContractLength, TotalInterestPayment, TotalPaidToDate) == ClosingBalance;

            return resultValue;
        }

        public override bool Validate()
        {
            throw new Exception("Use the Validate(decimal OriginalContractValue, decimal CreditLifePayment, int ContractLength, decimal TotalInterestPayment, decimal TotalPaidToDate, decimal ClosingBalance) overload method.");
        }
    }
}
