#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Validators
{
    public class ContractTerm: ValidatorBase
    {
        public ContractTerm(Dictionary<string, string> GeneralSettings)
            : base(GeneralSettings)
        {
        }

        public int CalculateCurrentContractLength(DateTime ContractStartDate)
        {
            TimeSpan contractLengthMonthsTimeSpan = new TimeSpan(DateTime.Now.Ticks - ContractStartDate.Ticks);
            return System.Convert.ToInt32(contractLengthMonthsTimeSpan.TotalDays / 30.6667);
        }

        public bool Validate(DateTime ContractStartDate, int ContractTerm)
        {
            bool resultValue = false;

            resultValue = CalculateCurrentContractLength(ContractStartDate) < ContractTerm;

            return resultValue;
        }

        public override bool Validate()
        {
            throw new Exception("The method or operation is not implemented.");
        }
    }
}
