#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Validators
{
    public class InDuplum : ValidatorBase
    {
        public InDuplum(Dictionary<string, string> GeneralSettings)
            : base(GeneralSettings)
        {
        }

        public decimal CalculateInDuplum(decimal ContractValue, decimal TotalInterestValue)
        {
            return TotalInterestValue - ContractValue;
        }

        public bool Validate(decimal ContractValue, decimal TotalInterestValue)
        {
            bool resultValue = false;

            resultValue = CalculateInDuplum(ContractValue, TotalInterestValue) > 0;

            return resultValue;
        }

        public override bool Validate()
        {
            throw new Exception("Use the Validate(decimal ContractValue, decimal TotalInterestValue) overload method.");
        }
    }
}
