#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace Validators
{
    public abstract class ValidatorBase
    {
        protected Dictionary<string, string> generalSettings;

        public ValidatorBase(Dictionary<string, string> GeneralSettings)
        {
            generalSettings = GeneralSettings;
        }

        public ValidatorBase()
        {
            generalSettings = new Dictionary<string, string>();
        }

        public abstract bool Validate();

        public Dictionary<string, string> GeneralSettings
        {
            get { return generalSettings; }
            set { generalSettings = value; }
        }

        protected string getGeneralSetting(string Key)
        {
            if (generalSettings.ContainsKey(Key))
            {
                return generalSettings[Key];
            }
            else
            {
                return null;
            }
        }

        protected decimal getDecimalValue(string Key)
        {
            return decimal.Parse((getGeneralSetting(Key) != null) ? getGeneralSetting(Key) : "0");
        }

        protected decimal getIntValue(string Key)
        {
            return int.Parse((getGeneralSetting(Key) != null) ? getGeneralSetting(Key) : "0");
        }
    }
}
