#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Data;
using System.Data.SqlClient;

/// <summary>
/// Summary description for Genesis
/// </summary>
[WebService(Namespace = "http://genesis.bluemarble.co.za/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Genesis : WebServiceBase {

    public Genesis () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 

        connectionStringKey = "GenesisConnectionString";
    }

    [WebMethod]
    public System.Data.DataTable ExecuteTable(Guid TransactionGuid, string CommandText, string ConnectionStringKey, System.Data.CommandType CommandType, string TableName,
params Common.Classes.DataParameter[] Parameters)
    {
        DataTable resultValue = null;

        connectionStringKey = ConnectionStringKey;

        OpenSqlConnection();

        if (Parameters != null)
        {
            foreach (Common.Classes.DataParameter p in Parameters)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.Add(new System.Data.SqlClient.SqlParameter(p.ParameterName, p.ParameterValue));
            }
        }

        //GetSqlCommand(CommandText, CommandType).Parameters.Add(new SqlParameter("@TransactionGuid", TransactionGuid));

        resultValue = GenerateTableFromReader(ExecuteReader(CommandText, CommandType), TableName);

        if (Parameters != null)
        {
            for (int i = Parameters.Length; i > 0; i--)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.RemoveAt(0);
            }
        }

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public object ExecuteScalar(Guid TransactionGuid, string CommandText, string ConnectionStringKey, System.Data.CommandType CommandType, string TableName,
params Common.Classes.DataParameter[] Parameters)
    {
        object resultValue = null;

        connectionStringKey = ConnectionStringKey;

        OpenSqlConnection();

        if (Parameters != null)
        {
            foreach (Common.Classes.DataParameter p in Parameters)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.Add(new System.Data.SqlClient.SqlParameter(p.ParameterName, p.ParameterValue));
            }
        }

        //GetSqlCommand(CommandText, CommandType).Parameters.Add(new SqlParameter("@TransactionGuid", TransactionGuid));

        resultValue = ExecuteScalar(CommandText, CommandType);

        if (Parameters != null)
        {
            for (int i = Parameters.Length; i > 0; i--)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.RemoveAt(0);
            }
        }

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public void ExecuteNonQuery(Guid TransactionGuid, string CommandText, string ConnectionStringKey, System.Data.CommandType CommandType, string TableName,
params Common.Classes.DataParameter[] Parameters)
    {
        connectionStringKey = ConnectionStringKey;

        OpenSqlConnection();

        if (Parameters != null)
        {
            foreach (Common.Classes.DataParameter p in Parameters)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.Add(new System.Data.SqlClient.SqlParameter(p.ParameterName, p.ParameterValue));
            }
        }

        //GetSqlCommand(CommandText, CommandType).Parameters.Add(new SqlParameter("@TransactionGuid", TransactionGuid));

        ExecuteNonQuery(CommandText, CommandType);

        if (Parameters != null)
        {
            for (int i = Parameters.Length; i > 0; i--)
            {
                GetSqlCommand(CommandText, CommandType).Parameters.RemoveAt(0);
            }
        }

        CloseSqlConnection();
    }
    
}

