#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;


/// <summary>
/// Summary description for KeepAlive
/// </summary>
[WebService(Namespace = "http://genesis.bluemarble.co.za/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class KeepAlive : System.Web.Services.WebService {

    const string dateTimeFormatString = "yyyy/MM/dd hh:mm:ss:fff";
    public KeepAlive () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public string Ping() {
        return DateTime.Now.ToString(dateTimeFormatString);
    }

    [WebMethod]
    public System.Xml.XmlNode Test(System.Xml.XmlNode TestNode)
    {
        System.Xml.XmlDocument resultValue = new System.Xml.XmlDocument();
        
        resultValue.LoadXml("<?xml version=\"1.0\"?>" + TestNode.InnerXml);

        DateTime webServiceStartTime = DateTime.Now;

        DateTime webServiceEndTime = DateTime.Now;

        System.Xml.XmlElement webServiceElement = resultValue.CreateElement("WebService");

        webServiceElement.Attributes.Append(resultValue.CreateAttribute("Start"));
        webServiceElement.Attributes.Append(resultValue.CreateAttribute("End"));

        webServiceElement.Attributes["Start"].Value = webServiceStartTime.ToString(dateTimeFormatString);
        webServiceElement.Attributes["End"].Value = webServiceEndTime.ToString(dateTimeFormatString);

        resultValue.DocumentElement.AppendChild(webServiceElement);

        return (System.Xml.XmlNode)resultValue.DocumentElement;
    }
}

