#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Data;
using System.Data.SqlClient;

/// <summary>
/// Summary description for Module
/// </summary>
[WebService(Namespace = "http://genesis.bluemarble.co.za/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Module : WebServiceBase
{

    public Module()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 

        connectionStringKey = "GenesisConnectionString";
    }

    [WebMethod]
    public DataTable GetApplicationRibbons(Guid SessionGuid)
    {
        if (base.AuthorizeSession(SessionGuid) == Guid.Empty)
        {
            return null;
        }

        DataTable resultValue = new DataTable("Module_Ribbon");

        connectionStringKey = "GenesisConnectionString";

        string selectManyApplicationRibbonsCommandText = "SelectManyModule_Ribbon";

        OpenSqlConnection();

        GetSqlCommand(selectManyApplicationRibbonsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));

        resultValue = GenerateTableFromReader(ExecuteReader(selectManyApplicationRibbonsCommandText, CommandType.StoredProcedure), "Module_Ribbon");

        GetSqlCommand(selectManyApplicationRibbonsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable GetRibbonBars(Guid SessionGuid, Guid RibbonGuid)
    {
        if (base.AuthorizeSession(SessionGuid) == Guid.Empty)
        {
            return null;
        }

        DataTable resultValue = new DataTable("Module_RibbonBar");

        connectionStringKey = "GenesisConnectionString";

        string selectManyApplicationRibbonBarsCommandText = "SelectManyModule_RibbonBar";

        OpenSqlConnection();

        GetSqlCommand(selectManyApplicationRibbonBarsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));
        GetSqlCommand(selectManyApplicationRibbonBarsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@RibbonGuid", RibbonGuid));

        resultValue = GenerateTableFromReader(ExecuteReader(selectManyApplicationRibbonBarsCommandText, CommandType.StoredProcedure), "Module_RibbonBar");

        GetSqlCommand(selectManyApplicationRibbonBarsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(1);
        GetSqlCommand(selectManyApplicationRibbonBarsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable GetBarItems(Guid SessionGuid, Guid RibbonBarGuid, Guid ParentBarItemGuid)
    {
        if (base.AuthorizeSession(SessionGuid) == Guid.Empty)
        {
            return null;
        }

        DataTable resultValue = new DataTable("Module_BarItem");

        connectionStringKey = "GenesisConnectionString";

        string selectManyApplicationRibbonBarItemsCommandText = "SelectManyModule_BarItem";

        OpenSqlConnection();

        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));
        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@ParentBarItemGuid", ParentBarItemGuid));
        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@RibbonBarGuid", RibbonBarGuid));

        resultValue = GenerateTableFromReader(ExecuteReader(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure), "Module_BarItem");

        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(2);
        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(1);
        GetSqlCommand(selectManyApplicationRibbonBarItemsCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable GetApplicationFiles(Guid SessionGuid, Guid ApplicationGuid)
    {
        if (base.AuthorizeSession(SessionGuid) == Guid.Empty)
        {
            return null;
        }

        DataTable resultValue = new DataTable("Module_File");

        connectionStringKey = "GenesisConnectionString";

        string selectManyApplicationFilesCommandText = "SelectManyModule_File";

        OpenSqlConnection();

        GetSqlCommand(selectManyApplicationFilesCommandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(selectManyApplicationFilesCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));

        if (ApplicationGuid != Guid.Empty)
        {
            GetSqlCommand(selectManyApplicationFilesCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@ApplicationGuid", ApplicationGuid));
        }

        resultValue = GenerateTableFromReader(ExecuteReader(selectManyApplicationFilesCommandText, CommandType.StoredProcedure), "Module_File");

        GetSqlCommand(selectManyApplicationFilesCommandText, CommandType.StoredProcedure).Parameters.Clear();

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable GetApplicationCommands(Guid SessionGuid, Guid FileGuid)
    {
        if (base.AuthorizeSession(SessionGuid) == Guid.Empty)
        {
            return null;
        }

        DataTable resultValue = new DataTable("Module_Command");

        connectionStringKey = "GenesisConnectionString";

        string selectManyCommandCommandText = "SelectManyModule_Command";

        OpenSqlConnection();

        GetSqlCommand(selectManyCommandCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));
        GetSqlCommand(selectManyCommandCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@FileGuid", FileGuid));

        resultValue = GenerateTableFromReader(ExecuteReader(selectManyCommandCommandText, CommandType.StoredProcedure), "Module_Command");

        GetSqlCommand(selectManyCommandCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(1);
        GetSqlCommand(selectManyCommandCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    #region Application
    [WebMethod]
    public DataTable ApplicationGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Application_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Application");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable ApplicationGetByApplicationGuid(Guid ApplicationGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Application_GetByApplicationGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Application");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool ApplicationUpdate(int ApplicationId, Guid ApplicationGuid, string ApplicationName, string ApplicationDescription, int Order, bool Visible)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Application_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationId", ApplicationId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationName", ApplicationName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationDescription", ApplicationDescription));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationOrder", Order));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationVisible", Visible));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int ApplicationInsert(Guid ApplicationGuid, string ApplicationName, string ApplicationDescription, int Order, bool Visible)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Application_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationName", ApplicationName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationDescription", ApplicationDescription));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationOrder", Order));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationVisible", Visible));


        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["ApplicationId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region File
    [WebMethod]
    public DataTable FileGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_File_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_File");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable FileGetByFileGuid(Guid FileGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_File_GetByFileGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileGuid", FileGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_File");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable FileGetByFileTypeId(int FileTypeId)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_File_GetByFileTypeId";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileTypeId", FileTypeId));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_File");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool FileUpdate(int FileId, Guid FileGuid, Guid ApplicationGuid, string FileName, string FileDescription, string FilePath, string FileUrl, int FileTypeId, int VersionMajor, int VersionMinor, int VersionBuild, int VersionRevision, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_File_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileGuid", FileGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalFileGuid", FileGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileId", FileId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileName", FileName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileDescription", FileDescription));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FilePath", FilePath));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileUrl", FileUrl));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionMajor", VersionMajor));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionMinor", VersionMinor));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionBuild", VersionBuild));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionRevision", VersionRevision));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileTypeId", FileTypeId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileOrder", Order));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int FileInsert(Guid FileGuid, Guid ApplicationGuid, string FileName, string FileDescription, string FilePath, string FileUrl, int FileTypeId, int VersionMajor, int VersionMinor, int VersionBuild, int VersionRevision, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_File_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileGuid", FileGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileName", FileName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileDescription", FileDescription));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FilePath", FilePath));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileUrl", FileUrl));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionMajor", VersionMajor));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionMinor", VersionMinor));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionBuild", VersionBuild));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileVersionRevision", VersionRevision));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileTypeId", FileTypeId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileOrder", Order));


        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["FileId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region Command
    [WebMethod]
    public DataTable CommandGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Command_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Command");

        CloseSqlConnection();

        return resultValue;
    }
    [WebMethod]
    public DataTable CommandGetListWithNullRecord()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Command_Get_WithNullRecord";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Command");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable CommandGetByCommandGuid(Guid CommandGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Command_GetByCommandGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Command");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool CommandUpdate(int CommandId, Guid CommandGuid, Guid FileGuid, string CommandName, string CommandDescription, string CommandCode, string CommandType)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Command_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalCommandGuid", CommandGuid));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandId", CommandId));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileGuid", FileGuid));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandName", CommandName));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandDescription", CommandDescription));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandCode", CommandCode));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandType", CommandType));

        bool resultValue = ExecuteNonQuery(commandText, System.Data.CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int CommandInsert(Guid CommandGuid, Guid FileGuid, string CommandName, string CommandDescription, string CommandCode, string CommandType)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Command_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandId", 1));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("FileGuid", FileGuid));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandName", CommandName));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandDescription", CommandDescription));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandCode", CommandCode));
        GetSqlCommand(commandText, System.Data.CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandType", CommandType));


        bool executeSuccess = ExecuteNonQuery(commandText, System.Data.CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["CommandId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region Ribbon
    [WebMethod]
    public DataTable RibbonGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Ribbon_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Ribbon");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RibbonGetByRibbonGuid(Guid RibbonGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Ribbon_GetByRibbonGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Ribbon");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool RibbonUpdate(int RibbonId, Guid RibbonGuid, Guid ApplicationGuid, string RibbonName, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Ribbon_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalRibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonId", RibbonId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonName", RibbonName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonOrder", Order));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonInsert(Guid RibbonGuid, Guid ApplicationGuid, string RibbonName, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_Ribbon_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonName", RibbonName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonOrder", Order));


        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["RibbonId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region RibbonBar
    [WebMethod]
    public DataTable RibbonBarGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_RibbonBar_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_RibbonBar");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RibbonBarGetByRibbonBarGuid(Guid RibbonBarGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_RibbonBar_GetByRibbonBarGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_RibbonBar");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool RibbonBarUpdate(int RibbonBarId, Guid RibbonBarGuid, Guid RibbonGuid, string RibbonBarName, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_RibbonBar_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalRibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarId", RibbonBarId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarName", RibbonBarName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarOrder", Order));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonBarInsert(Guid RibbonBarGuid, Guid RibbonGuid, string RibbonBarName, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_RibbonBar_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarName", RibbonBarName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarOrder", Order));


        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["RibbonBarId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region BarItem
    [WebMethod]
    public DataTable BarItemGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_BarItem_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_BarItem");

        CloseSqlConnection();

        return resultValue;
    }
    [WebMethod]
    public DataTable BarItemGetListWithNullRecord()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_BarItem_Get_WithNullRecord";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_BarItem");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable BarItemGetByBarItemGuid(Guid BarItemGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_BarItem_GetByBarItemGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemGuid", BarItemGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_BarItem");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool BarItemUpdate(int BarItemId, Guid BarItemGuid, Guid RibbonBarGuid, Guid ParentBarItemGuid, Guid CommandGuid, string BarItemName, string BarItemImage, int BarItemImageSize, int BarItemTypeId, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_BarItem_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemGuid", BarItemGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalBarItemGuid", BarItemGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemId", BarItemId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ParentBarItemGuid", ParentBarItemGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemName", BarItemName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemImage", BarItemImage));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemImageSize", BarItemImageSize));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemTypeId", BarItemTypeId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemOrder", Order));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int BarItemInsert(Guid BarItemGuid, Guid RibbonBarGuid, Guid ParentBarItemGuid, Guid CommandGuid, string BarItemName, string BarItemImage, int BarItemImageSize, int BarItemTypeId, int Order)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Module_BarItem_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemGuid", BarItemGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ParentBarItemGuid", ParentBarItemGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemName", BarItemName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemImage", BarItemImage));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemImageSize", BarItemImageSize));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemTypeId", BarItemTypeId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("BarItemOrder", Order));

        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["BarItemId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion
}

