#region Copyright Clause
/*
 * Blue Marble Genesis Smart Client Framework
 * 
 * Copyright  2009 Blue Marble. All rights reserved.
 * 
 * This code is protected from any unauthorized duplication or viewing under
 * international copyright laws. Unauthorized access to this code is prosecutable
 * under the full extent of the law.
 */
#endregion

using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Data;
using System.Data.SqlClient;

/// <summary>
/// Summary description for Security
/// </summary>
[WebService(Namespace = "http://genesis.bluemarble.co.za/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Security : WebServiceBase
{

    public Security()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 

        connectionStringKey = "GenesisConnectionString";
    }

    [WebMethod]
    public Guid AuthorizeUser(Guid ApplicationGuid, string Username, string Password)
    {
        Guid resultValue = Guid.Empty;

        connectionStringKey = "GenesisConnectionString";

        string selectManyLookupCommandText = "AuthorizeUser";

        OpenSqlConnection();

        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@ApplicationGuid", ApplicationGuid));
        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@Username", Username));
        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@Password", Password));

        resultValue = (Guid)ExecuteScalar(selectManyLookupCommandText, CommandType.StoredProcedure);

        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(2);
        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(1);
        GetSqlCommand(selectManyLookupCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    #region Transaction
    [WebMethod]
    public Guid CreateTransaction(string TransactionCode, Guid SessionGuid)
    {
        Guid resultValue = Guid.Empty;

        connectionStringKey = "GenesisConnectionString";

        string createTransactionCommandText = "CreateTransaction";

        OpenSqlConnection();

        GetSqlCommand(createTransactionCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@SessionGuid", SessionGuid));
        GetSqlCommand(createTransactionCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@TransactionCode", TransactionCode));

        resultValue = (Guid)ExecuteScalar(createTransactionCommandText, CommandType.StoredProcedure);

        GetSqlCommand(createTransactionCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(1);
        GetSqlCommand(createTransactionCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public void CompleteTransaction(Guid TransactionGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string completeTransactionCommandText = "CreateTransaction";

        OpenSqlConnection();

        GetSqlCommand(completeTransactionCommandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("@TransactionGuid", TransactionGuid));

        ExecuteNonQuery(completeTransactionCommandText, CommandType.StoredProcedure);

        GetSqlCommand(completeTransactionCommandText, CommandType.StoredProcedure).Parameters.RemoveAt(0);

        CloseSqlConnection();
    }
    #endregion

    #region Role
    [WebMethod]
    public DataTable RoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByRoleGuid(Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByRoleGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByUserGuid(Guid UserGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByUserGuidFromSecurity_UserRole";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByApplicationGuid(Guid ApplicationGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByApplicationGuidFromSecurity_ApplicationRole";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByCommandGuid(Guid CommandGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByCommandGuidFromSecurity_CommandRole";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByRibbonGuid(Guid RibbonGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByRibbonGuidFromSecurity_RibbonRole";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable RoleGetByRibbonBarGuid(Guid RibbonBarGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_GetByRibbonBarGuidFromSecurity_RibbonBarRole";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_Role");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool RoleUpdate(int RoleId, Guid RoleGuid, string RoleName, string RoleDescription)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalRoleGuid", RoleGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleId", RoleId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleName", RoleName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleDescription", RoleDescription));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RoleInsert(Guid RoleGuid, string RoleName, string RoleDescription)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_Role_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleName", RoleName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleDescription", RoleDescription));

        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["RoleId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region User
    [WebMethod]
    public DataTable UserGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_User_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_User");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public DataTable UserGetByUserGuid(Guid UserGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_User_GetByUserGuid";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_User");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public bool UserUpdate(int UserId, Guid UserGuid, string UserName, string Password, string Email, bool Active, string StartupScript)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_User_Update";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("OriginalUserGuid", UserGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserId", UserId));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserName", UserName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Password", Password));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Email", Email));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Active", Active));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("StartupScript", StartupScript));

        bool resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int UserInsert(Guid UserGuid, string UserName, string Password, string Email, bool Active, string StartupScript)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_User_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserId", 1));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserName", UserName));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Password", Password));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Email", Email));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("Active", Active));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("StartupScript", StartupScript));

        bool executeSuccess = ExecuteNonQuery(commandText, CommandType.StoredProcedure) > 0;

        int resultValue = 0;

        if (executeSuccess)
        {
            resultValue = System.Convert.ToInt32(base.command.Parameters["UserId"].Value);
        }

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region UserRole
    [WebMethod]
    public DataTable UserRoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_UserRole_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_UserRole");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int UserRoleInsert(Guid UserGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_UserRole_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int UserRoleDelete(Guid UserGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_UserRole_Delete";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("UserGuid", UserGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region ApplicationRole
    [WebMethod]
    public DataTable ApplicationRoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_ApplicationRole_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_ApplicationRole");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int ApplicationRoleInsert(Guid ApplicationGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_ApplicationRole_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int ApplicationRoleDelete(Guid ApplicationGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_ApplicationRole_Delete";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("ApplicationGuid", ApplicationGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region CommandRole
    [WebMethod]
    public DataTable CommandRoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_CommandRole_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_CommandRole");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int CommandRoleInsert(Guid CommandGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_CommandRole_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int CommandRoleDelete(Guid CommandGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_CommandRole_Delete";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("CommandGuid", CommandGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region RibbonRole
    [WebMethod]
    public DataTable RibbonRoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonRole_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_RibbonRole");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonRoleInsert(Guid RibbonGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonRole_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonRoleDelete(Guid RibbonGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonRole_Delete";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonGuid", RibbonGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }
    #endregion

    #region RibbonBarRole
    [WebMethod]
    public DataTable RibbonBarRoleGetList()
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonBarRole_Get_List";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        DataTable resultValue = GenerateTableFromReader(ExecuteReader(commandText, CommandType.StoredProcedure), "Security_RibbonBarRole");

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonBarRoleInsert(Guid RibbonBarGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonBarRole_Insert";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }

    [WebMethod]
    public int RibbonBarRoleDelete(Guid RibbonBarGuid, Guid RoleGuid)
    {
        connectionStringKey = "GenesisConnectionString";

        string commandText = "Security_RibbonBarRole_Delete";

        OpenSqlConnection();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Clear();

        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RibbonBarGuid", RibbonBarGuid));
        GetSqlCommand(commandText, CommandType.StoredProcedure).Parameters.Add(new SqlParameter("RoleGuid", RoleGuid));

        int resultValue = ExecuteNonQuery(commandText, CommandType.StoredProcedure);

        CloseSqlConnection();

        return resultValue;
    }
    #endregion
}

